@echo off
rem
rem Place this .bat file in a permanent location
rem To associate/de-associate it with .kfx files right-click this file and select "Run as administrator"
rem Each run toggles the association on or off
rem Once associated this batch file will execute whenever .kfx files are to be opened
rem When executed it copies the .kfx file to a temporary .azw8 file and opens it with Kindle Preview 3
rem Kindle Previewer 3 must already be installed for this to work
rem For more information: http://www.mobileread.com/forums/showthread.php?p=3288333#post3288333
rem
rem Version History
rem 1.0.0 - 24 Oct 2016 - initial release
rem
rem
del /q %tmp%\open_previewer_kfx_*.azw8
if [%1]==[] goto :setup
if not exist "%localappdata%\Amazon\Kindle Previewer 3\Kindle Previewer 3.exe" goto :nokpr
if not exist %1 goto :nofile
rem
rem Copy .kfx file to .azw8 and open with Kindle Previewer 3
rem
setlocal
:tryunique
set "PreviewFileName=%tmp%\open_previewer_kfx_%RANDOM%%RANDOM%%RANDOM%%RANDOM%.azw8"
if exist "%PreviewFileName%" goto :tryunique
copy %1 "%PreviewFileName%"
start "Kindle Previewer 3" "%localappdata%\Amazon\Kindle Previewer 3\Kindle Previewer 3.exe" "%PreviewFileName%"
endlocal
goto :done
:nokpr
echo Failed -- Kindle Previewer 3 is not installed for the current user
goto :wait
:nofile
echo Failed -- %1 does not exist
goto :wait
:setup
echo Setup mode...
if not exist "%localappdata%\Amazon\Kindle Previewer 3\Kindle Previewer 3.exe" goto :nokpr
assoc .kfx && goto :remove
rem
rem Associate .kfx files with this bat file
rem
assoc .kfx=kfx_auto_file|| goto :failed
ftype kfx_auto_file=%0 "%%1" || goto :failed
echo Success -- The .kfx file association is now set
goto :wait
:remove
rem
rem Remove association with .kfx
rem
assoc .kfx=|| goto :failed
ftype kfx_auto_file=|| goto :failed
reg delete HKCR\kfx_auto_file /f|| goto :failed
echo Success -- The .kfx file association has been removed
goto :wait
:failed
echo Failed -- Must use "Run as administrator" for setup
:wait
pause
:done